%module ccdlib
%{
#include "ccdlib.h"
%}

extern void robitest();

extern enum CCDLIB_ErrorEnum CCDLIB_AddPictures
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  long * addpuffer,
  unsigned short piccount
);

enum CCDLIB_ErrorEnum CCDLIB_MoveAddfieldToPicture
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  long * addpuffer,
  unsigned short piccount
);

enum CCDLIB_ErrorEnum CCDLIB_SetNoiseInPicture
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  enum CCDLIB_NoiseTypeEnum noisetype
);

static short CCDLIB_GaussDevRandom
(
  short mean,
  short dynamik
);

static double CCDLIB_GetBernoulliNumber
(
  unsigned long fieldwidth,
  unsigned long fieldindex
);

static enum CCDLIB_ErrorEnum CCDLIB_GetDeconvolutionIndices
(
  long lowpasswidth,
  long highpasswidth,
  long * coefficients,
  long * divisionfactor
);

static enum CCDLIB_ErrorEnum CCDLIB_GetConvolutionIndices
(
  long lowpasswidth,
  long * coefficients,
  long * divisionfactor
);

enum CCDLIB_ErrorEnum CCDLIB_DeconvolutionFunction
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  unsigned long lopasswidth,
  unsigned long hipasswidth
);

enum CCDLIB_ErrorEnum CCDLIB_ConvolutionFunction
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  unsigned long lopasswidth
);

enum CCDLIB_ErrorEnum CCDLIB_RetrieveHistogram
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  long * histogramfield
);

enum CCDLIB_ErrorEnum CCDLIB_GetMaximumInHistogram
(
  long * histogramfield,
  short dynamik,
  long * lowestposition,
  long * highestposition,
  long * maximumposition,
  long * maximalvalue,
  double * maximumpart,
  double * entropy
);

enum CCDLIB_ErrorEnum CCDLIB_GetLocalStatistics
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  double * mean,
  double * sigma
);

# enum CCDLIB_ErrorEnum CCDLIB_GetNthMaximumInHistogram
#(
#  long * histogramfield,
#  short dynamik,
#  short maximumnumber,
#  enum CCDLIB_PeakHeightCriterionEnum peakheightcriterion,
#  enum CCDLIB_PeakWidthCriterionEnum peakwidthcriterion,
#  long * maximumposition,
#  long * maximalvalue,
#  double * maximumpart
#);

enum CCDLIB_ErrorEnum CCDLIB_EqualizeHistogram
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture
);

enum CCDLIB_ErrorEnum CCDLIB_SubtractBackground
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture
);

enum CCDLIB_ErrorEnum CCDLIB_ModifyHistogram
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  enum CCDLIB_HistogramModifierEnum histogrammodifier,
  double gamma
);

enum CCDLIB_ErrorEnum CCDLIB_MaskedFilterOperation
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  unsigned long maskdiameter,
  enum CCDLIB_OperationTypeEnum operationtype
);

static short CCDLIB_GetMedianFromArray
(
  short *values_pd,
  long valuenumber_n
);

enum CCDLIB_ErrorEnum CCDLIB_CalcXYGradientFromPic
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
        short * picture,
        CCDLIB_GradientUnion * gradient
);

enum CCDLIB_ErrorEnum CCDLIB_SobelGradientFromPic
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  CCDLIB_GradientUnion * gradient
);

enum CCDLIB_ErrorEnum CCDLIB_CalcAbsGradientFromPic
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  CCDLIB_GradientUnion * gradient,
  enum CCDLIB_GradientOperationEnum operationtype
);

enum CCDLIB_ErrorEnum CCDLIB_BinarizePicture
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam,
  short * picture,
  short treshold,
  short logreyval,
  short higreyval
);

BooleanType CCDLIB_CheckRectangleValues
(
  CCDLIB_RectangleStruct * picturerect,
  CCDLIB_PictureparamStruct * pictureparam
);

#enum CCDLIB_ErrorEnum CCDLIB_ScaleAndRotateRegion
#(
#  short * sourcepicture,
#  long srcpiclinesize,
#  long srcpiccolumnsize,
#  double srcregionxpos,
#  double srcregionypos,
#  double srcregionxsize,
#  double srcregionysize,
#  double srcregturnxpos,
#  double srcregturnypos,
#  double srcregionrotangle,
#  double xmagnification,
#  double ymagnification,
#  double srcxpixelsize,
#  double srcypixelsize,
#  short * destpicture,
#  long destpiclinesize,
#  long destregturnxpos,
#  long destregturnypos,
#  short fillgreyvalue
#);
